SystemOrganization addCategory: #'GT-EventRecorder-Server'!
SystemOrganization addCategory: 'GT-EventRecorder-Server-Core'!
SystemOrganization addCategory: 'GT-EventRecorder-Server-Tests'!

Object subclass: #GTEventRecorderDelegate
	instanceVariableNames: 'dispatcher putHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Core'!

!GTEventRecorderDelegate methodsFor: 'public' stamp: 'JurajKubelka 11/15/2015 17:10'!
handleRequest: request
	^ dispatcher handleRequest: request! !

!GTEventRecorderDelegate methodsFor: 'initialization' stamp: 'JurajKubelka 11/15/2015 16:57'!
initialize
	super initialize.
	putHandler := GTEventRecorderPutHandler new.
	putHandler storage: (GTEventRecorderFileStorage new
		directory: FileLocator home / 'gt' / 'events';
		yourself).
	dispatcher := ZnDispatcherDelegate new.
	self initializeDispatcher! !

!GTEventRecorderDelegate methodsFor: 'initialization' stamp: 'JurajKubelka 11/15/2015 17:26'!
initializeDispatcher
	| okResponse |
	okResponse := [ :request :response | ZnResponse ok: (ZnEntity text: 'OK') ].
	dispatcher 
		map: '/' to: okResponse;
		map: '/gt' to: okResponse;
		map: '/gt/' to: okResponse;
		map: '/gt/events' to: putHandler;
		map: '/gt/events/' to: putHandler;
		yourself! !

!GTEventRecorderDelegate methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 17:16'!
putHandler
	"for the testing purpose"
	^ putHandler! !

Object subclass: #GTEventRecorderFileStorage
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Core'!

!GTEventRecorderFileStorage methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 11/15/2015 16:21'!
atCategory: aString put: aByteArray
	| subDirectory date monthDirectoryName monthDirectory fileName file |
	subDirectory := (self directory / aString) ensureCreateDirectory; yourself.
	date := Date today.
	monthDirectoryName := date year printString, (date month index printStringBase: 10 nDigits: 2).
	monthDirectory := subDirectory / monthDirectoryName.
	monthDirectory ensureCreateDirectory.
	fileName := UUID new printString.
	file := monthDirectory / fileName.
	file exists ifTrue: [ 
		fileName := fileName, '-time-', DateAndTime now asUnixTime printString.
		file := monthDirectory / fileName ].
	file ensureDelete.
	file writeStreamDo: [ :aStream | aStream nextPutAll: aByteArray ].
	^ aString, '/', monthDirectoryName, '/', fileName! !

!GTEventRecorderFileStorage methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:53'!
directory
	^ directory! !

!GTEventRecorderFileStorage methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:53'!
directory: anObject
	directory := anObject! !

!GTEventRecorderFileStorage methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 11/15/2015 16:29'!
put: aByteArray
	^ self atCategory: #unspecified put: aByteArray! !

Object subclass: #GTEventRecorderPutHandler
	instanceVariableNames: 'storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Core'!

!GTEventRecorderPutHandler methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 17:18'!
directory: aFileReference 
	self storage directory: aFileReference! !

!GTEventRecorderPutHandler methodsFor: 'testing' stamp: 'JurajKubelka 11/15/2015 15:41'!
hasCategoryAndDataParts: aCollection
	aCollection pairsDo: [ :aCategoryPart :aDataPart |
		aCategoryPart fieldName = 'category' ifFalse: [ ^ false ].
		aDataPart fieldName = 'data' ifFalse: [ ^ false ].
		(aCategoryPart contentType matches: ZnMimeType textPlain) ifFalse: [ ^ false ].
		(aDataPart contentType matches: ZnMimeType applicationOctetStream) ifFalse: [ ^ false ].
	 ].
	^ true! !

!GTEventRecorderPutHandler methodsFor: 'testing' stamp: 'JurajKubelka 11/15/2015 15:32'!
isApplicationOctetStream: aZnRequest
	^ aZnRequest hasEntity and: [ aZnRequest contentType matches: ZnMimeType applicationOctetStream ]! !

!GTEventRecorderPutHandler methodsFor: 'testing' stamp: 'JurajKubelka 11/15/2015 15:42'!
isMultiPartFormData: aZnRequest
	^ aZnRequest hasEntity 
		and: [ (aZnRequest contentType matches: ZnMimeType multiPartFormData)
		and: [ (aZnRequest entity isEmpty not)
		and: [ aZnRequest entity parts size even
		and: [ self hasCategoryAndDataParts: aZnRequest entity parts ] ] ] ]! !

!GTEventRecorderPutHandler methodsFor: 'private' stamp: 'JurajKubelka 11/15/2015 15:11'!
saveByteArray: aByteArray
	"storage is responsible for storing aByteArray.
	It returns location."
	^ self storage put: aByteArray.! !

!GTEventRecorderPutHandler methodsFor: 'private' stamp: 'JurajKubelka 11/15/2015 15:27'!
saveByteArray: aByteArray category: aString 
	"storage is responsible for storing aByteArray.
	It returns location."
	^ self storage atCategory: aString put: aByteArray.! !

!GTEventRecorderPutHandler methodsFor: 'private' stamp: 'JurajKubelka 11/15/2015 15:31'!
saveMultiPartFormData: anEntity
	"storage is responsible for storing aByteArray.
	It returns location."
	| keys |
	keys := OrderedCollection new.
	anEntity parts pairsDo: [ :category :data | | key |
		key := self saveByteArray: data fieldValue category: category fieldValue.
		keys addLast: key.
	 ].
	^ keys size printString! !

!GTEventRecorderPutHandler methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 13:18'!
storage
	^ storage! !

!GTEventRecorderPutHandler methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 13:18'!
storage: anObject
	storage := anObject! !

!GTEventRecorderPutHandler methodsFor: 'evaluating' stamp: 'JurajKubelka 11/15/2015 17:22'!
value: aZnRequest value: aZnResponse
	| badRequest key |
	badRequest := [ ^ ZnResponse badRequest: aZnRequest ].
	aZnRequest method = #GET	ifTrue: [ ^ ZnResponse ok: (ZnEntity text: 'OK') ].
	aZnRequest method = #PUT ifFalse: [ badRequest value ].
	(self isApplicationOctetStream: aZnRequest) ifTrue: [ 
			[ key := self saveByteArray: aZnRequest entity bytes ] on: Error do: badRequest.
			^ ZnResponse created: key ].
	(self isMultiPartFormData: aZnRequest) ifTrue: [ 
			[ key := self saveMultiPartFormData: aZnRequest entity ] on: Error do: badRequest.
			^ ZnResponse created: key ].
	badRequest value.! !

Object subclass: #GTEventRecorderServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Core'!

!GTEventRecorderServer class methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:50'!
start
	"self start"
	(ZnServer startDefaultOn: 8080)
		route: 'Default GT-EventRecorder-Server';
		delegate: GTEventRecorderDelegate new.! !

!GTEventRecorderServer class methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:44'!
stop
	"self stop"
	ZnServer stopDefault! !

TestCase subclass: #GTEventRecorderDelegateTest
	instanceVariableNames: 'serverSemaphore delegate server client fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Tests'!

!GTEventRecorderDelegateTest commentStamp: '<historical>' prior: 0!
A GTEventRecorderDelegateTest is a test class for testing the behavior of GTEventRecorderDelegate!

!GTEventRecorderDelegateTest methodsFor: 'converting' stamp: 'JurajKubelka 11/15/2015 17:29'!
assertLocation: location input: input
	| file output |
	file := fileSystem workingDirectory resolveString: location.
	self assert: file exists.
	output := file binaryReadStreamDo: [ :stream | stream upToEnd ].
	self assert: output equals: input! !

!GTEventRecorderDelegateTest methodsFor: 'running' stamp: 'JurajKubelka 11/15/2015 17:41'!
setUp
	super setUp.
	serverSemaphore := Semaphore new.
	fileSystem := FileSystem memory.
	delegate := GTEventRecorderDelegate new.
	delegate putHandler directory: fileSystem workingDirectory.
	server := GTEventRecorderTestServer new.
	server initializeUsingDelegate: delegate semaphore: serverSemaphore.
	client := ZnClient new
		url: server url;
		followRedirects: false;
		numberOfRetries: 0;
		enforceHttpSuccess: true;
		logToTranscript;
		yourself.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:23'!
testHandleGetFromEvents
	| contents |
	client path: '/gt/events'; get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:23'!
testHandleGetFromEvents2
	| contents |
	client path: '/gt/events/'; get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:20'!
testHandleGetFromGT
	| contents |
	client path: '/gt'; get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:24'!
testHandleGetFromGT2
	| contents |
	client path: '/gt/'; get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 16:50'!
testHandleGetFromRoot
	| contents |
	client get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:24'!
testHandleGetFromRoot2
	| contents |
	client path: '//'; get.
	self assert: client isSuccess.
	contents := client response contents.
	self assert: contents isString.
	self assert: contents equals: 'OK'.! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:29'!
testHandlePut
	| data entity |
	data := #[1 2 3 4].
	entity := ZnByteArrayEntity bytes: data.
	client
		addPathSegment: 'gt';
		addPathSegment: 'events';
		entity: entity;
		put.
	self assert: client isSuccess.
	self assert: client isCreated.
	self assertLocation: client response location input: data
	! !

!GTEventRecorderDelegateTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:29'!
testHandlePut2
	| data entity |
	data := #[1 2 3 4].
	entity := ZnByteArrayEntity bytes: data.
	client
		path: 'gt/events/';
		entity: entity;
		put.
	self assert: client isSuccess.
	self assert: client isCreated.
	self assertLocation: client response location input: data
! !

TestCase subclass: #GTEventRecorderFileStorageTest
	instanceVariableNames: 'fileSystem storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Tests'!

!GTEventRecorderFileStorageTest commentStamp: '<historical>' prior: 0!
A GTEventRecorderFileStorageTest is a test class for testing the behavior of GTEventRecorderFileStorage!

!GTEventRecorderFileStorageTest methodsFor: 'asserting' stamp: 'JurajKubelka 11/15/2015 16:31'!
assertLocation: location input: input
	| file output |
	file := storage directory resolveString: location.
	self assert: file exists.
	output := file binaryReadStreamDo: [ :stream | stream upToEnd ].
	self assert: output equals: input! !

!GTEventRecorderFileStorageTest methodsFor: 'running' stamp: 'JurajKubelka 11/15/2015 15:56'!
setUp
	super setUp.
	fileSystem := FileSystem memory.
	storage := GTEventRecorderFileStorage new.
	storage directory: fileSystem workingDirectory.! !

!GTEventRecorderFileStorageTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 16:31'!
testAtCategoryPut
	| location input category |
	input := #[1 2 3 4].
	category := 'category1'.
	location := storage atCategory: category put: input.
	self assertLocation: location input: input! !

!GTEventRecorderFileStorageTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 15:53'!
testDirectory
	self assert: storage directory exists.
	self assert: storage directory isWritable.! !

!GTEventRecorderFileStorageTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 16:32'!
testPut
	| location input |
	input := #[ 1 2 3 4 ].
	location := storage put: input.
	self assertLocation: location input: input! !

TestCase subclass: #GTEventRecorderPutHandlerTest
	instanceVariableNames: 'receivedContents receiverSemaphore handler delegate server url data client location storage entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Server-Tests'!

!GTEventRecorderPutHandlerTest commentStamp: '<historical>' prior: 0!
A GTERServerDelegateTest is a test class for testing the behavior of GTERServerDelegate!

!GTEventRecorderPutHandlerTest methodsFor: 'asserting' stamp: 'JurajKubelka 11/15/2015 13:21'!
assertReceiverSemaphore
	self deny: (receiverSemaphore waitTimeoutMSecs: 200)! !

!GTEventRecorderPutHandlerTest methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:28'!
atCategory: aString put: aByteArray 
	^ self put: aString -> aByteArray! !

!GTEventRecorderPutHandlerTest methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 15:11'!
put: aByteArray 
	| key |
	key := (receivedContents size + 1) printString.
	receivedContents nextPut: key -> aByteArray.
	receiverSemaphore signal.
	^ key! !

!GTEventRecorderPutHandlerTest methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 13:19'!
server
	^ server! !

!GTEventRecorderPutHandlerTest methodsFor: 'running' stamp: 'JurajKubelka 11/15/2015 17:37'!
setUp
	super setUp.
	self setUpServer.
	client := ZnClient new
		url: server url;
		followRedirects: false;
		numberOfRetries: 0;
		enforceHttpSuccess: true;
		logToTranscript;
		yourself.! !

!GTEventRecorderPutHandlerTest methodsFor: 'running' stamp: 'JurajKubelka 11/15/2015 17:41'!
setUpServer
	receivedContents := WaitfreeQueue new.
	receiverSemaphore := Semaphore new.
	handler := GTEventRecorderPutHandler new.
	handler storage: self.
	delegate := ZnDispatcherDelegate new.
	delegate map: '/gt/events' to: handler.
	server := GTEventRecorderTestServer new.
	server initializeUsingDelegate: delegate semaphore: receiverSemaphore.
	server url
		addPathSegment: 'gt';
		addPathSegment: 'events'! !

!GTEventRecorderPutHandlerTest methodsFor: 'accessing' stamp: 'JurajKubelka 11/15/2015 14:49'!
storage
	storage ifNil: [ storage := Dictionary new ].
	receivedContents flush: [ :association |
		storage at: association key put: association value ].
	^ storage! !

!GTEventRecorderPutHandlerTest methodsFor: 'running' stamp: 'JurajKubelka 11/15/2015 12:51'!
tearDown
	super tearDown.
	server stop.! !

!GTEventRecorderPutHandlerTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 15:13'!
testPutByteArrayEntity
	data := #[1 2 3 4].
	entity := ZnByteArrayEntity bytes: data.
	client
		entity: entity;
		put.
	self assert: client isSuccess.
	self assert: client isCreated.
	location := client response location asZnUrl.
	self assert: (self storage at: location lastPathSegment) equals: data.
! !

!GTEventRecorderPutHandlerTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 15:30'!
testPutMultiPartFormDataEntity
	data := #[1 2 3 4].
	entity := ZnMultiPartFormDataEntity new.
	entity 
		addPart: (ZnMimePart fieldName: 'category' value: 'category1');
		addPart: (ZnMimePart fieldName: 'data' value: data).
	client
		entity: entity;
		put.
	self assert: client isSuccess.
	self assert: client isCreated.
	location := client response location asZnUrl.
	self assert: client response location equals: '1'.
	self assert: (self storage at: '1') equals: 'category1' -> data.
! !

!GTEventRecorderPutHandlerTest methodsFor: 'tests' stamp: 'JurajKubelka 11/15/2015 17:32'!
testPutMultiPartFormDataEntity2
	| data2 data3 |
	data := #[1 2 3 4].
	data2 := #[5 6].
	data3 := #[7 8 9].
	entity := ZnMultiPartFormDataEntity new.
	entity 
		addPart: (ZnMimePart fieldName: 'category' value: 'category1');
		addPart: (ZnMimePart fieldName: 'data' value: data);
		addPart: (ZnMimePart fieldName: 'category' value: 'category2');
		addPart: (ZnMimePart fieldName: 'data' value: data2);
		addPart: (ZnMimePart fieldName: 'category' value: 'category1');
		addPart: (ZnMimePart fieldName: 'data' value: data3).
	client
		entity: entity;
		put.
	self assert: client isSuccess.
	self assert: client isCreated.
	location := client response location asZnUrl.
	self assert: client response location equals: '3'.
	self assert: (self storage at: '1') equals: 'category1' -> data.
	self assert: (self storage at: '2') equals: 'category2' -> data2.
	self assert: (self storage at: '3') equals: 'category1' -> data3.
! !
